AWSTemplateFormatVersion: "2010-09-09"

Description:  This template deploys an NAT gateway for a VPC.

#Metadata

Parameters: 
  VPCName:
    Type: String
    Description: The name of the VPC.
    Default: project3-vpc-stack  

  VpcID: 
    Type: String 
    Default: ''
    Description: Network stack    
  
  PublicSubnet1:
    Type: String
    Description: The public subnet located in Availability Zone 1.

  PublicSubnet2:
    Type: String
    Description: The public subnet located in Availability Zone 2.

  PrivateSubnet1:
    Type: String
    Description: The private subnet located in Availability Zone 1.

  PrivateSubnet2:
    Type: String
    Description: The private subnet located in Availability Zone 2.


Resources:
  NatGateway1EIP:
    Type: AWS::EC2::EIP
    Properties:
      Domain: vpc
      Tags:
        - Key: Name
          Value: EIP1

  NatGateway2EIP:
    Type: AWS::EC2::EIP
    Properties:
      Domain: vpc
      Tags:
        - Key: Name
          Value: EIP2

  NatGateway1:
    Type: AWS::EC2::NatGateway
    Properties:
      AllocationId: !GetAtt NatGateway1EIP.AllocationId
      SubnetId: !Ref PublicSubnet1

  NatGateway2:
    Type: AWS::EC2::NatGateway
    Properties:
      AllocationId: !GetAtt NatGateway2EIP.AllocationId
      SubnetId: !Ref PublicSubnet2

  PrivateRouteTable1:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref VpcID
      Tags:
        - Key: Name
          Value: !Sub ${VPCName} Private Routes (AZ1)

  DefaultPrivateRoute1:
    Type: AWS::EC2::Route
    Properties:
      RouteTableId: !Ref PrivateRouteTable1
      DestinationCidrBlock: 0.0.0.0/0
      NatGatewayId: !Ref NatGateway1

  PrivateSubnet1RouteTableAssociation:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PrivateRouteTable1
      SubnetId: !Ref PrivateSubnet1

  PrivateRouteTable2:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref VpcID
      Tags:
        - Key: Name
          Value: !Sub ${VPCName} Private Routes (AZ2)

  DefaultPrivateRoute2:
    Type: AWS::EC2::Route
    Properties:
      RouteTableId: !Ref PrivateRouteTable2
      DestinationCidrBlock: 0.0.0.0/0
      NatGatewayId: !Ref NatGateway2

  PrivateSubnet2RouteTableAssociation:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PrivateRouteTable2
      SubnetId: !Ref PrivateSubnet2


Outputs: 
  NatGateway1:
    Description: NatGatewayId
    Value: !Ref NatGateway1
    Export: 
      Name: NatGateway1Id

  NatGateway2:
    Description: NatGatewayId
    Value: !Ref NatGateway2
    Export: 
      Name: NatGateway2Id